﻿using System;
using System.Windows.Forms;
using NationalInstruments.DAQmx;

namespace ThermistorApp
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnGetTemperatureData_Click(object sender, EventArgs e)
        {
            Task analogInTask = new Task();

            AIChannel myAIChannel;

            myAIChannel = analogInTask.AIChannels.CreateVoltageChannel(
                "dev1/ai0",
                "myAIChannel",
                AITerminalConfiguration.Rse,
                0,
                5,
                AIVoltageUnits.Volts
                );

            AnalogSingleChannelReader reader = new AnalogSingleChannelReader(analogInTask.Stream);

            double Vout = reader.ReadSingleSample();

            double Vin = 5;
            double Ro = 10000; // 10k Resistor
            double Rt = (Vout * Ro) / (Vin - Vout);
            //Rt = 10000; //Used for Testing.Setting Rt = 10k should give TempC = 25

            //Steinhart Constants
            double A = 0.001129148;
            double B = 0.000234125;
            double C = 0.0000000876741;

            //Steinhart - Hart Equation
            double TempK = 1 / (A + (B * Math.Log(Rt)) + C * Math.Pow(Math.Log(Rt),3) );

            //Convert from Kelvin to Celsius
            double thermistorTempC = TempK - 273.15;

            txtTempData.Text = thermistorTempC.ToString("0.00");
        }
    }
}
